'''
This is the implement of average_pooling backdoor defense 
'''

import os
from copy import deepcopy

import torch
import torchvision.transforms as transforms

from .base import Base
from ..utils import test
from attack.originalimagenet import Origdataset
from settings import base_args, base_config

    
def MeanUpsample(x, scale):
    n, c, h, w = x.shape
    out = torch.zeros(n, c, h, scale, w, scale).to(x.device) + x.view(n,c,h,1,w,1)
    out = out.view(n, c, scale*h, scale*w)
    return out


'''
class Avg_up_dataset(Origdataset):
    def __init__(self, dataset):
        self.dataset = dataset
        
    def preprocess(self, data, deg_scale):
        
        scale=round(deg_scale)
        A = torch.nn.AdaptiveAvgPool2d((256//scale,256//scale))
        y = A(data)
        Ap = lambda z: MeanUpsample(z,scale)
        Apy = Ap(y)
        
        return Apy
    
    def __getitem__(self, index):
        path, target = self.samples[index]
        img = self.loader(path)       
'''


class Avg_up(Base):


    def __init__(self,
                 seed=0,
                 deterministic=False):

        super(Avg_up, self).__init__(seed=seed, deterministic=deterministic)
     

    def test(self, model, dataset, schedule, size_map=None, pad=None):

        defense_dataset = deepcopy(dataset)

        print("++++++++++++++++++Results from before the defense+++++++++++++++++++++")
        base_args.useAVGUP = False
        print("useAVGUP:", base_args.useAVGUP)
        test(model, dataset, schedule)
        print("+++++++++++++++++++++++++++++++++End++++++++++++++++++++++++++++++++++")
        print("++++++++++++++++++Results from after the defense+++++++++++++++++++++")
        base_args.useAVGUP = True
        print("useAVGUP:", base_args.useAVGUP)
        test(model, defense_dataset, schedule)
        print("+++++++++++++++++++++++++++++++++End++++++++++++++++++++++++++++++++++")
